scheduler._reset_scale=function(){
	//current mode doesn't support scales
	//we mustn't call reset_scale for such modes, so it just to be sure
	if (!this.templates[this._mode+"_date"]) return;
        if(this._mode == 'week')
            this._table_view = true;

	var h=this._els["dhx_cal_header"][0];
	var b=this._els["dhx_cal_data"][0];
	var c = this.config;

	h.innerHTML="";
	b.scrollTop=0; //fix flickering in FF
	b.innerHTML="";


	var str=((c.readonly||(!c.drag_resize))?" dhx_resize_denied":"")+((c.readonly||(!c.drag_move))?" dhx_move_denied":"");
	if (str) b.className = "dhx_cal_data"+str;


	this._cols=[];	//store for data section
	this._colsS={height:0};
	this._dy_shift=0;

	this.set_sizes();
	var summ=parseInt(h.style.width); //border delta
	var left=0;

	var d,dd,sd,today;
	dd=this.date[this._mode+"_start"](new Date(this._date.valueOf()));
	d=sd=this._table_view?scheduler.date.week_start(dd):dd;
	today=this.date.date_part(new Date());

	//reset date in header
	var ed=scheduler.date.add(dd,1,this._mode);

        if(this._mode == 'week')
            var count = 2;
        else
            var count = 7;

	if (!this._table_view){
		var count_n = this.date["get_"+this._mode+"_end"];
		if (count_n) ed = count_n(dd);
		count = Math.round((ed.valueOf()-dd.valueOf())/(1000*60*60*24));
	}

	this._min_date=d;
	this._els["dhx_cal_date"][0].innerHTML=this.templates[this._mode+"_date"](dd,ed,this._mode);


	for (var i=0; i<count; i++){
		this._cols[i]=Math.floor(summ/(count-i));

		this._render_x_header(i,left,d,h);
		if (!this._table_view){
			var scales=document.createElement("DIV");
			var cls = "dhx_scale_holder"
			if (d.valueOf()==today.valueOf()) cls = "dhx_scale_holder_now";
			scales.className=cls+" "+this.templates.week_date_class(d,today);
			this.set_xy(scales,this._cols[i]-1,c.hour_size_px*(c.last_hour-c.first_hour),left+this.xy.scale_width+1,0);//-1 for border
			b.appendChild(scales);
		}

		d=this.date.add(d,1,"day")
		summ-=this._cols[i];
		left+=this._cols[i];
		this._colsS[i]=((this._cols[i-1]||0)+(this._colsS[i-1]||(this._table_view?0:this.xy.scale_width+2))-1);
	}
	this._max_date=d;
	this._colsS[count]=this._cols[count-1]+this._colsS[count-1];

	if (this._table_view)
            if(this._mode == 'week')
                this._reset_week_scale(b,dd,sd);
            else
		this._reset_month_scale(b,dd,sd);
	else{
		this._reset_hours_scale(b,dd,sd);
		if (c.multi_day){
			var c1 = document.createElement("DIV");
			c1.className="dhx_multi_day";
			c1.style.visibility="hidden";
			this.set_xy(c1,parseInt(h.style.width),0,this.xy.scale_width,0);
			b.appendChild(c1);
			var c2 = c1.cloneNode(true);
			c2.className="dhx_multi_day_icon";
			c2.style.visibility="hidden";
			this.set_xy(c2,this.xy.scale_width-1,0,0,0);
			b.appendChild(c2);

			this._els["dhx_multi_day"]=[c1,c2];
		}
	}
}

scheduler._reset_week_scale=function(b,dd,sd){
        var ed=scheduler.date.add(sd,1,"week");
        var cd=new Date();
	this.date.date_part(cd);
	this.date.date_part(sd);

	var rows=Math.ceil((ed.valueOf()-sd.valueOf())/(60*60*24*1000*2));
	var tdcss=[];
	var height=(Math.floor(b.clientHeight/rows)-22);

	this._colsS.height=height+22;
	var h = this._colsS.heights = [];
	for (var i=0; i<=7; i++)
		tdcss[i]=" style='height:"+height+"px; width:"+((this._cols[i]||0)-1)+"px;' "



	var cellheight = 0;
	this._min_date=sd;
	var html="<table cellpadding='0' cellspacing='0'>";
	for (var i=0; i<rows; i++){
		html+="<tr>";
			for (var j=0; j<2; j++){
				html+="<td";
				var cls = "";
				if (sd.valueOf()==cd.valueOf())
					cls='dhx_now';
				html+=" class='"+cls+" "+this.templates.month_date_class(sd,cd)+"' ";
				html+="><div class='dhx_month_head'>"+this.templates.week_scale_date(sd)+"</div><div class='dhx_month_body' "+tdcss[j]+"></div></td>"
				sd=this.date.add(sd,1,"day");
                                if(i==3)
                                    break;
			}
		html+="</tr>";
		h[i] = cellheight;
		cellheight+=this._colsS.height;
	}
	html+="</table>";
	this._max_date=sd;

	b.innerHTML=html;
	return sd;
}

scheduler._mouse_coords=function(ev){
	var pos;
	var b=document.body;
	var d = document.documentElement;
	if(ev.pageX || ev.pageY)
	    pos={x:ev.pageX, y:ev.pageY};
	else pos={
	    x:ev.clientX + (b.scrollLeft||d.scrollLeft||0) - b.clientLeft,
	    y:ev.clientY + (b.scrollTop||d.scrollTop||0) - b.clientTop
	}

	//apply layout
	pos.x-=getAbsoluteLeft(this._obj)+(this._table_view?0:this.xy.scale_width);
	pos.y-=getAbsoluteTop(this._obj)+this.xy.nav_height+(this._dy_shift||0)+this.xy.scale_height-this._els["dhx_cal_data"][0].scrollTop;
	pos.ev = ev;

	var handler = this["mouse_"+this._mode];
	if (handler)
		return handler.call(this,pos);

	//transform to date
	if (!this._table_view){
		pos.x=Math.max(0,Math.ceil(pos.x/this._cols[0])-1);
		pos.y=Math.max(0,Math.ceil(pos.y*60/(this.config.time_step*this.config.hour_size_px))-1)+this.config.first_hour*(60/this.config.time_step);
	} else {
		var dy=0;
		for (dy=1; dy < this._colsS.heights.length; dy++)
			if (this._colsS.heights[dy]>pos.y) break;
                this._mode == 'week'?n=2:n=7;
		pos.y=(Math.max(0,Math.ceil(pos.x/this._cols[0])-1)+Math.max(0,dy-1)*n)*24*60/this.config.time_step;
		pos.x=0;
	}

	return pos;
}

scheduler._pre_render_events=function(evs,hold){
	var hb = this.xy.bar_height;
	var h_old = this._colsS.heights;
	var h=this._colsS.heights=[0,0,0,0,0,0,0];

	if (!this._table_view) evs=this._pre_render_events_line(evs,hold); //ignore long events for now
	else evs=this._pre_render_events_table(evs,hold);

	if (this._table_view){
		if (hold)
			this._colsS.heights = h_old;
		else {
			var evl = this._els["dhx_cal_data"][0].firstChild;
			if (evl.rows){
				for (var i=0; i<evl.rows.length; i++){
					h[i]++;
					if ((h[i])*hb > this._colsS.height-22){ // 22 - height of cell's header
						//we have overflow, update heights
						var cells = evl.rows[i].cells;
						for (var j=0; j < cells.length; j++) {
							cells[j].childNodes[1].style.height = h[i]*hb+"px";
						}
						h[i]=(h[i-1]||0)+cells[0].offsetHeight;
					}
					h[i]=(h[i-1]||0)+evl.rows[i].cells[0].offsetHeight;
				}
				h.unshift(0);
				if (evl.parentNode.offsetHeight<evl.parentNode.scrollHeight && !evl._h_fix){
					//we have v-scroll, decrease last day cell
					for (var i=0; i<evl.rows.length; i++){
                                            if(this._mode=='month'){
						var cell = evl.rows[i].cells[6].childNodes[0];
						var w = cell.offsetWidth-scheduler.xy.scroll_width+"px";
						cell.style.width = w;
						cell.nextSibling.style.width = w;
                                            }
					}
					evl._h_fix=true;
				}
			} else{

				if (!evs.length && this._els["dhx_multi_day"][0].style.visibility == "visible")
					h[0]=-1;
				if (evs.length || h[0]==-1){
					//shift days to have space for multiday events
					var childs = evl.parentNode.childNodes;
					var dh = (h[0]+1)*hb+"px";
					for (var i=0; i<childs.length; i++)
						if (this._colsS[i])
							childs[i].style.top=dh;
					var last = this._els["dhx_multi_day"][0];
					last.style.top = "0px";
					last.style.height=dh;
					last.style.visibility=(h[0]==-1?"hidden":"visible");
					last=this._els["dhx_multi_day"][1];
					last.style.height=dh;
					last.style.visibility=(h[0]==-1?"hidden":"visible");
					last.className=h[0]?"dhx_multi_day_icon":"dhx_multi_day_icon_small";

					this._dy_shift=(h[0]+1)*hb;
					h[0] = 0;
				}

			}
		}
	}

	return evs;
};